#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
    читаем /etc/passwd, генерируем (по нему и /etc/tcb) ldif для всех юзеров системы,
    кроме особого юзера 500.500
    пишем на стандартный вывод, вызывать pwd2ldif > users.ldif
    
    (C) GLeb 2004 <gleb@asd.iao.ru>
    
    2007 внимание, какой-то $$удак в Альте решил, что scanner, camera и т.д. теперь группы >500,
    из-за чего возникают проблемы с переносом пользователей и сменой групп, ОСТОРОЖНО!
"""

## ÞÉÔÁÅÍ /etc/passwd, выплёвываем ldif

# ------------------------------------------------------------------------------

## шаблон для ldif
class LDIFTEMPLATE:
	def __init__(self, domain):
		self.ou = 'People'
		
		self.dclist = []
		organization = domain.strip().split('.')
		
		self.dclist.append(organization[0])
		
		dom = ""
		delimiter = ""
		for i in organization[1:]:
			dom = dom + delimiter + i
			delimiter = '.'
			
		self.dclist.append(dom)
		
		#cnt = 0
			    
		#for i in organization:
		#	if cnt > 
		#	self.dclist.append(i)
		#	cnt = cnt + 1
			
	
		self.objectClassList = []
		self.objectClassList.append('account')
		self.objectClassList.append('posixAccount')
		self.objectClassList.append('top')
		self.objectClassList.append('shadowAccount')
	
		self.dctKeywords = {}
		self.dctKeywords['passwd'] = 'userPassword: {crypt}'
		self.dctKeywords['lastchange'] = 'shadowLastChange: '
		self.dctKeywords['shell'] = 'loginShell: '
		self.dctKeywords['uid'] = 'uidNumber: '
		self.dctKeywords['gid'] = 'gidNumber: '
		self.dctKeywords['home'] = 'homeDirectory: '
		self.dctKeywords['comment']='gecos: '
	# --------------------------------------------------------------------------
	def  PrintDnLine(self,username):
		l = 'dn: uid='+username+','+'ou='+self.ou
		if len(self.dclist) > 0:
			for i in self.dclist:
				l = l+','+'dc='+i
		return l
# ------------------------------------------------------------------------------
	# строка uid
	def PrintUID(self, userobject):
		return 'uid: '+ str(userobject.user)
# ------------------------------------------------------------------------------
	# строка cn
	def PrintCN(self, userobject):
		return 'cn: '+ str(userobject.user)
# ------------------------------------------------------------------------------
	# строки класса объекта, пароля
	## @param userobject : объект класса USER
	## @return строка типа objectClass
	def  PrintObjectClassAndPassword(self, userobject):
		l  = ''
		
		for i in self.objectClassList:
			l = l + 'objectClass: '+i + '\n'
		
		#l = l +self.dctKeywords['passwd'] +userobject.passwd + '\n'
		for item in self.dctKeywords.keys():
			data = eval('userobject.'+item)
			l = l + self.dctKeywords[item] + str(data) + '\n'
		
		return l
	# ----------------------------------------------------------------------
	
# ==============================================================================
## ÄÁÎÎÙÅ Ï ÐÏÌØÚÏвÁÔÅÌÅ
class USER:
    def __init__(self,user=None,uid=0,gid=0,home='/dev/null',shell='/bin/false',lastchange=12372,comment='asd'):
        self.user=user
        self.uid = uid
        self.gid = gid
        self.home = home
        self.shell = shell
        self.lastchange = lastchange
	if comment == '' or comment == ' ':
		self.comment = self.user
	else:
    		self.comment = comment
        self.passwd = None
# ------------------------------------------------------------------------------
## ÐÒÏÞÉÔÁÔØ /etc/passwd
## @return [USER,]

def ReadPasswds():
    file = open('/etc/passwd')
    
    userlist = []

    for line in file:
        userrecord = line.strip().split(':')
        
        # ftp:x:14:50:FTP User:/var/ftp:/dev/null
        # 0 - user
        #     1
        #       2 : uid
        #           3: gid
        #              4: comment
        #                      5: home
        #                               6: shell
        
        #print userrecord[2]," ->",
	if int(userrecord[2]) > 500 : 
	    if '$' in userrecord[0]:
		continue
	    #print userrecord[0]
            user=userrecord[0]
            uid = userrecord[2]
            gid = userrecord[3]
            comment = userrecord[4]
            home = userrecord[5]
	    if home == '/dev/null':
		    continue
            shell = userrecord[6]
            
            aUser = USER(user=user,uid=uid, gid=gid, home=home,shell=shell,comment=comment)
            userlist.append(aUser)
        else:
            continue
    
    file.close()
    
    return userlist
# ------------------------------------------------------------------------------
## берём из списка отбъектов типа USER пользователя, сканируем /etc/tcb,
## добавляем в него passwd

def ScanTCBForPasswd(listOfUsers):
	if listOfUsers:
		for item in listOfUsers:
			filename = '/etc/tcb/'+item.user+'/shadow'
			try:
				file = open(filename,'r')
				info = file.readline().strip().split(':')
				file.close()
				item.passwd = info[1]
			except:
				pass
#-------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
## берём пользователя, сравниваем с шаблоном LDIF и 
## печатаем строки для ldif - скрипта

def PrintLdifLine(template, userobject):
	if userobject.passwd:
		print template.PrintDnLine(userobject.user)
		print template.PrintUID(userobject)
		print template.PrintCN(userobject)
		print template.PrintObjectClassAndPassword(userobject)
# ------------------------------------------------------------------------------
if __name__ == '__main__':
	listOfUsers = ReadPasswds()
	#print listOfUsers
	ScanTCBForPasswd(listOfUsers)
	
	aLDIF = LDIFTEMPLATE('eureca.ru')
	
	for i in listOfUsers:
		PrintLdifLine(aLDIF,i)
		

